HTMLTableElement (Java SE 26 & JDK 26)
Description: declaration: module: jdk.xml.dom, package: org.w3c.dom.html, interface: HTMLTableElement
Keywords: org.w3c.dom.html.HTMLTableElement interface

# Interface HTMLTableElement

All Superinterfaces:
  `Element, HTMLElement, Node`

public interface HTMLTableElement extends HTMLElement
The create* and delete* methods on the table allow authors to construct and modify tables. HTML 4.0 specifies that only one of each of the `CAPTION` , `THEAD` , and `TFOOT` elements may exist in a table. Therefore, if one exists, and the createTHead() or createTFoot() method is called, the method returns the existing THead or TFoot element. See the TABLE element definition in HTML 4.0.

See also the Document Object Model (DOM) Level 2 Specification.

Since:
  1.4, DOM Level 2

- ## Field Summary

  ### Fields declared in interface Node

  `ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`
  Modifier and Type
  Field
  Description
  `static final short`
  `ATTRIBUTE_NODE`
  The node is an `Attr`.
  `static final short`
  `CDATA_SECTION_NODE`
  The node is a `CDATASection`.
  `static final short`
  `COMMENT_NODE`
  The node is a `Comment`.
  `static final short`
  `DOCUMENT_FRAGMENT_NODE`
  The node is a `DocumentFragment`.
  `static final short`
  `DOCUMENT_NODE`
  The node is a `Document`.
  `static final short`
  `DOCUMENT_POSITION_CONTAINED_BY`
  The node is contained by the reference node.
  `static final short`
  `DOCUMENT_POSITION_CONTAINS`
  The node contains the reference node.
  `static final short`
  `DOCUMENT_POSITION_DISCONNECTED`
  The two nodes are disconnected.
  `static final short`
  `DOCUMENT_POSITION_FOLLOWING`
  The node follows the reference node.
  `static final short`
  `DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC`
  The determination of preceding versus following is implementation-specific.
  `static final short`
  `DOCUMENT_POSITION_PRECEDING`
  The second node precedes the reference node.
  `static final short`
  `DOCUMENT_TYPE_NODE`
  The node is a `DocumentType`.
  `static final short`
  `ELEMENT_NODE`
  The node is an `Element`.
  `static final short`
  `ENTITY_NODE`
  The node is an `Entity`.
  `static final short`
  `ENTITY_REFERENCE_NODE`
  The node is an `EntityReference`.
  `static final short`
  `NOTATION_NODE`
  The node is a `Notation`.
  `static final short`
  `PROCESSING_INSTRUCTION_NODE`
  The node is a `ProcessingInstruction`.
  `static final short`
  `TEXT_NODE`
  The node is a `Text` node.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `HTMLElement`
  `createCaption()`
  Create a new table caption object or return an existing one.
  `HTMLElement`
  `createTFoot()`
  Create a table footer row or return an existing one.
  `HTMLElement`
  `createTHead()`
  Create a table header row or return an existing one.
  `void`
  `deleteCaption()`
  Delete the table caption, if one exists.
  `void`
  `deleteRow(int index)`
  Delete a table row.
  `void`
  `deleteTFoot()`
  Delete the footer from the table, if one exists.
  `void`
  `deleteTHead()`
  Delete the header from the table, if one exists.
  `String`
  `getAlign()`
  Specifies the table's position with respect to the rest of the document.
  `String`
  `getBgColor()`
  Cell background color.
  `String`
  `getBorder()`
  The width of the border around the table.
  `HTMLTableCaptionElement`
  `getCaption()`
  Returns the table's `CAPTION` , or void if none exists.
  `String`
  `getCellPadding()`
  Specifies the horizontal and vertical space between cell content and cell borders.
  `String`
  `getCellSpacing()`
  Specifies the horizontal and vertical separation between cells.
  `String`
  `getFrame()`
  Specifies which external table borders to render.
  `HTMLCollection`
  `getRows()`
  Returns a collection of all the rows in the table, including all in `THEAD` , `TFOOT` , all `TBODY` elements.
  `String`
  `getRules()`
  Specifies which internal table borders to render.
  `String`
  `getSummary()`
  Description about the purpose or structure of a table.
  `HTMLCollection`
  `getTBodies()`
  Returns a collection of the defined table bodies.
  `HTMLTableSectionElement`
  `getTFoot()`
  Returns the table's `TFOOT` , or `null` if none exists.
  `HTMLTableSectionElement`
  `getTHead()`
  Returns the table's `THEAD` , or `null` if none exists.
  `String`
  `getWidth()`
  Specifies the desired table width.
  `HTMLElement`
  `insertRow(int index)`
  Insert a new empty row in the table.
  `void`
  `setAlign(String align)`
  `void`
  `setBgColor(String bgColor)`
  `void`
  `setBorder(String border)`
  `void`
  `setCaption(HTMLTableCaptionElement caption)`
  `void`
  `setCellPadding(String cellPadding)`
  `void`
  `setCellSpacing(String cellSpacing)`
  `void`
  `setFrame(String frame)`
  `void`
  `setRules(String rules)`
  `void`
  `setSummary(String summary)`
  `void`
  `setTFoot(HTMLTableSectionElement tFoot)`
  `void`
  `setTHead(HTMLTableSectionElement tHead)`
  `void`
  `setWidth(String width)`

  ### Methods declared in interface Element

  `getAttribute, getAttributeNode, getAttributeNodeNS, getAttributeNS, getElementsByTagName, getElementsByTagNameNS, getSchemaTypeInfo, getTagName, hasAttribute, hasAttributeNS, removeAttribute, removeAttributeNode, removeAttributeNS, setAttribute, setAttributeNode, setAttributeNodeNS, setAttributeNS, setIdAttribute, setIdAttributeNode, setIdAttributeNS`
  Modifier and Type
  Method
  Description
  `String`
  `getAttribute(String name)`
  Retrieves an attribute value by name.
  `Attr`
  `getAttributeNode(String name)`
  Retrieves an attribute node by name.
  `Attr`
  `getAttributeNodeNS(String namespaceURI, String localName)`
  Retrieves an `Attr` node by local name and namespace URI.
  `String`
  `getAttributeNS(String namespaceURI, String localName)`
  Retrieves an attribute value by local name and namespace URI.
  `NodeList`
  `getElementsByTagName(String name)`
  Returns a `NodeList` of all descendant `Elements` with a given tag name, in document order.
  `NodeList`
  `getElementsByTagNameNS(String namespaceURI, String localName)`
  Returns a `NodeList` of all the descendant `Elements` with a given local name and namespace URI in document order.
  `TypeInfo`
  `getSchemaTypeInfo()`
  The type information associated with this element.
  `String`
  `getTagName()`
  The name of the element.
  `boolean`
  `hasAttribute(String name)`
  Returns `true` when an attribute with a given name is specified on this element or has a default value, `false` otherwise.
  `boolean`
  `hasAttributeNS(String namespaceURI, String localName)`
  Returns `true` when an attribute with a given local name and namespace URI is specified on this element or has a default value, `false` otherwise.
  `void`
  `removeAttribute(String name)`
  Removes an attribute by name.
  `Attr`
  `removeAttributeNode(Attr oldAttr)`
  Removes the specified attribute node.
  `void`
  `removeAttributeNS(String namespaceURI, String localName)`
  Removes an attribute by local name and namespace URI.
  `void`
  `setAttribute(String name, String value)`
  Adds a new attribute.
  `Attr`
  `setAttributeNode(Attr newAttr)`
  Adds a new attribute node.
  `Attr`
  `setAttributeNodeNS(Attr newAttr)`
  Adds a new attribute.
  `void`
  `setAttributeNS(String namespaceURI, String qualifiedName, String value)`
  Adds a new attribute.
  `void`
  `setIdAttribute(String name, boolean isId)`
  If the parameter `isId` is `true`, this method declares the specified attribute to be a user-determined ID attribute .
  `void`
  `setIdAttributeNode(Attr idAttr, boolean isId)`
  If the parameter `isId` is `true`, this method declares the specified attribute to be a user-determined ID attribute .
  `void`
  `setIdAttributeNS(String namespaceURI, String localName, boolean isId)`
  If the parameter `isId` is `true`, this method declares the specified attribute to be a user-determined ID attribute .

  ### Methods declared in interface HTMLElement

  `getClassName, getDir, getId, getLang, getTitle, setClassName, setDir, setId, setLang, setTitle`
  Modifier and Type
  Method
  Description
  `String`
  `getClassName()`
  The class attribute of the element.
  `String`
  `getDir()`
  Specifies the base direction of directionally neutral text and the directionality of tables.
  `String`
  `getId()`
  The element's identifier.
  `String`
  `getLang()`
  Language code defined in RFC 1766.
  `String`
  `getTitle()`
  The element's advisory title.
  `void`
  `setClassName(String className)`
  `void`
  `setDir(String dir)`
  `void`
  `setId(String id)`
  `void`
  `setLang(String lang)`
  `void`
  `setTitle(String title)`

  ### Methods declared in interface Node

  `appendChild, cloneNode, compareDocumentPosition, getAttributes, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeName, getNodeType, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getTextContent, getUserData, hasAttributes, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`
  Modifier and Type
  Method
  Description
  `Node`
  `appendChild(Node newChild)`
  Adds the node `newChild` to the end of the list of children of this node.
  `Node`
  `cloneNode(boolean deep)`
  Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes.
  `short`
  `compareDocumentPosition(Node other)`
  Compares the reference node, i.e. the node on which this method is being called, with a node, i.e. the one passed as a parameter, with regard to their position in the document and according to the document order.
  `NamedNodeMap`
  `getAttributes()`
  A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.
  `String`
  `getBaseURI()`
  The absolute base URI of this node or `null` if the implementation wasn't able to obtain an absolute URI.
  `NodeList`
  `getChildNodes()`
  A `NodeList` that contains all children of this node.
  `Object`
  `getFeature(String feature, String version)`
  This method returns a specialized object which implements the specialized APIs of the specified feature and version, as specified in .
  `Node`
  `getFirstChild()`
  The first child of this node.
  `Node`
  `getLastChild()`
  The last child of this node.
  `String`
  `getLocalName()`
  Returns the local part of the qualified name of this node.
  `String`
  `getNamespaceURI()`
  The namespace URI of this node, or `null` if it is unspecified (see ).
  `Node`
  `getNextSibling()`
  The node immediately following this node.
  `String`
  `getNodeName()`
  The name of this node, depending on its type; see the table above.
  `short`
  `getNodeType()`
  A code representing the type of the underlying object, as defined above.
  `String`
  `getNodeValue()`
  The value of this node, depending on its type; see the table above.
  `Document`
  `getOwnerDocument()`
  The `Document` object associated with this node.
  `Node`
  `getParentNode()`
  The parent of this node.
  `String`
  `getPrefix()`
  The namespace prefix of this node, or `null` if it is unspecified.
  `Node`
  `getPreviousSibling()`
  The node immediately preceding this node.
  `String`
  `getTextContent()`
  This attribute returns the text content of this node and its descendants.
  `Object`
  `getUserData(String key)`
  Retrieves the object associated to a key on a this node.
  `boolean`
  `hasAttributes()`
  Returns whether this node (if it is an element) has any attributes.
  `boolean`
  `hasChildNodes()`
  Returns whether this node has any children.
  `Node`
  `insertBefore(Node newChild, Node refChild)`
  Inserts the node `newChild` before the existing child node `refChild`.
  `boolean`
  `isDefaultNamespace(String namespaceURI)`
  This method checks if the specified `namespaceURI` is the default namespace or not.
  `boolean`
  `isEqualNode(Node arg)`
  Tests whether two nodes are equal.
  `boolean`
  `isSameNode(Node other)`
  Returns whether this node is the same node as the given one.
  `boolean`
  `isSupported(String feature, String version)`
  Tests whether the DOM implementation implements a specific feature and that feature is supported by this node, as specified in .
  `String`
  `lookupNamespaceURI(String prefix)`
  Look up the namespace URI associated to the given prefix, starting from this node.
  `String`
  `lookupPrefix(String namespaceURI)`
  Look up the prefix associated to the given namespace URI, starting from this node.
  `void`
  `normalize()`
  Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only structure (e.g., elements, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are neither adjacent `Text` nodes nor empty `Text` nodes.
  `Node`
  `removeChild(Node oldChild)`
  Removes the child node indicated by `oldChild` from the list of children, and returns it.
  `Node`
  `replaceChild(Node newChild, Node oldChild)`
  Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.
  `void`
  `setNodeValue(String nodeValue)`
  The value of this node, depending on its type; see the table above.
  `void`
  `setPrefix(String prefix)`
  The namespace prefix of this node, or `null` if it is unspecified.
  `void`
  `setTextContent(String textContent)`
  This attribute returns the text content of this node and its descendants.
  `Object`
  `setUserData(String key, Object data, UserDataHandler handler)`
  Associate an object to a key on this node.

- ## Method Details

  - ### getCaption

    HTMLTableCaptionElement getCaption()
    Returns the table's `CAPTION` , or void if none exists.

  - ### setCaption

    void setCaption(HTMLTableCaptionElement caption)

  - ### getTHead

    HTMLTableSectionElement getTHead()
    Returns the table's `THEAD` , or `null` if none exists.

  - ### setTHead

    void setTHead(HTMLTableSectionElement tHead)

  - ### getTFoot

    HTMLTableSectionElement getTFoot()
    Returns the table's `TFOOT` , or `null` if none exists.

  - ### setTFoot

    void setTFoot(HTMLTableSectionElement tFoot)

  - ### getRows

    HTMLCollection getRows()
    Returns a collection of all the rows in the table, including all in `THEAD` , `TFOOT` , all `TBODY` elements.

  - ### getTBodies

    HTMLCollection getTBodies()
    Returns a collection of the defined table bodies.

  - ### getAlign

    String getAlign()
    Specifies the table's position with respect to the rest of the document. See the align attribute definition in HTML 4.0. This attribute is deprecated in HTML 4.0.

  - ### setAlign

    void setAlign(String align)

  - ### getBgColor

    String getBgColor()
    Cell background color. See the bgcolor attribute definition in HTML 4.0. This attribute is deprecated in HTML 4.0.

  - ### setBgColor

    void setBgColor(String bgColor)

  - ### getBorder

    String getBorder()
    The width of the border around the table. See the border attribute definition in HTML 4.0.

  - ### setBorder

    void setBorder(String border)

  - ### getCellPadding

    String getCellPadding()
    Specifies the horizontal and vertical space between cell content and cell borders. See the cellpadding attribute definition in HTML 4.0.

  - ### setCellPadding

    void setCellPadding(String cellPadding)

  - ### getCellSpacing

    String getCellSpacing()
    Specifies the horizontal and vertical separation between cells. See the cellspacing attribute definition in HTML 4.0.

  - ### setCellSpacing

    void setCellSpacing(String cellSpacing)

  - ### getFrame

    String getFrame()
    Specifies which external table borders to render. See the frame attribute definition in HTML 4.0.

  - ### setFrame

    void setFrame(String frame)

  - ### getRules

    String getRules()
    Specifies which internal table borders to render. See the rules attribute definition in HTML 4.0.

  - ### setRules

    void setRules(String rules)

  - ### getSummary

    String getSummary()
    Description about the purpose or structure of a table. See the summary attribute definition in HTML 4.0.

  - ### setSummary

    void setSummary(String summary)

  - ### getWidth

    String getWidth()
    Specifies the desired table width. See the width attribute definition in HTML 4.0.

  - ### setWidth

    void setWidth(String width)

  - ### createTHead

    HTMLElement createTHead()
    Create a table header row or return an existing one.
    Returns:
      A new table header element (`THEAD` ).

  - ### deleteTHead

    void deleteTHead()
    Delete the header from the table, if one exists.

  - ### createTFoot

    HTMLElement createTFoot()
    Create a table footer row or return an existing one.
    Returns:
      A footer element (`TFOOT` ).

  - ### deleteTFoot

    void deleteTFoot()
    Delete the footer from the table, if one exists.

  - ### createCaption

    HTMLElement createCaption()
    Create a new table caption object or return an existing one.
    Returns:
      A `CAPTION` element.

  - ### deleteCaption

    void deleteCaption()
    Delete the table caption, if one exists.

  - ### insertRow

    HTMLElement insertRow(int index) throws DOMException
    Insert a new empty row in the table. The new row is inserted immediately before and in the same section as the current `index` th row in the table. If `index` is equal to the number of rows, the new row is appended. In addition, when the table is empty the row is inserted into a `TBODY` which is created and inserted into the table. Note. A table row cannot be empty according to HTML 4.0 Recommendation.
    Parameters:
      `index` - The row number where to insert a new row. This index starts from 0 and is relative to all the rows contained inside the table, regardless of section parentage.
    Returns:
      The newly created row.
    Throws:
      `DOMException` - INDEX_SIZE_ERR: Raised if the specified index is greater than the number of rows or if the index is negative.

  - ### deleteRow

    void deleteRow(int index) throws DOMException
    Delete a table row.
    Parameters:
      `index` - The index of the row to be deleted. This index starts from 0 and is relative to all the rows contained inside the table, regardless of section parentage.
    Throws:
      `DOMException` - INDEX_SIZE_ERR: Raised if the specified index is greater than or equal to the number of rows or if the index is negative.